Index: lib/misc.c
===================================================================
--- lib/misc.c	(revision 285b55d3b38d6e1c8b3fc4a64945f2bb9ace07f4)
+++ lib/misc.c	(revision d444c09e6c7ac6fc3c1686af0e63c09805d8cd00)
@@ -545,2 +545,50 @@
 	return reply;
 }
+
+/* Word wrapping. Yes, I know this isn't UTF-8 clean. I'm willing to take the risk. */
+char *word_wrap( char *msg, int line_len )
+{
+	GString *ret = g_string_sized_new( strlen( msg ) + 16 );
+	
+	while( strlen( msg ) > line_len )
+	{
+		int i;
+		
+		/* First try to find out if there's a newline already. Don't
+		   want to add more splits than necessary. */
+		for( i = line_len; i > 0 && msg[i] != '\n'; i -- );
+		if( msg[i] == '\n' )
+		{
+			g_string_append_len( ret, msg, i + 1 );
+			msg += i + 1;
+			continue;
+		}
+		
+		for( i = line_len; i > 0; i -- )
+		{
+			if( msg[i] == '-' )
+			{
+				g_string_append_len( ret, msg, i + 1 );
+				g_string_append_c( ret, '\n' );
+				msg += i + 1;
+				break;
+			}
+			else if( msg[i] == ' ' )
+			{
+				g_string_append_len( ret, msg, i );
+				g_string_append_c( ret, '\n' );
+				msg += i + 1;
+				break;
+			}
+		}
+		if( i == 0 )
+		{
+			g_string_append_len( ret, msg, line_len );
+			g_string_append_c( ret, '\n' );
+			msg += line_len;
+		}
+	}
+	g_string_append( ret, msg );
+	
+	return g_string_free( ret, FALSE );
+}
Index: lib/misc.h
===================================================================
--- lib/misc.h	(revision 285b55d3b38d6e1c8b3fc4a64945f2bb9ace07f4)
+++ lib/misc.h	(revision d444c09e6c7ac6fc3c1686af0e63c09805d8cd00)
@@ -64,3 +64,5 @@
 G_MODULE_EXPORT struct ns_srv_reply *srv_lookup( char *service, char *protocol, char *domain );
 
+G_MODULE_EXPORT char *word_wrap( char *msg, int line_len );
+
 #endif
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision 285b55d3b38d6e1c8b3fc4a64945f2bb9ace07f4)
+++ protocols/nogaim.c	(revision d444c09e6c7ac6fc3c1686af0e63c09805d8cd00)
@@ -606,4 +606,5 @@
 {
 	irc_t *irc = ic->irc;
+	char *wrapped;
 	user_t *u;
 	
@@ -648,35 +649,7 @@
 		strip_html( msg );
 
-	while( strlen( msg ) > 425 )
-	{
-		char tmp, *nl;
-		
-		tmp = msg[425];
-		msg[425] = 0;
-		
-		/* If there's a newline/space in this string, split up there,
-		   looks a bit prettier. */
-		if( ( nl = strrchr( msg, '\n' ) ) || ( nl = strrchr( msg, ' ' ) ) )
-		{
-			msg[425] = tmp;
-			tmp = *nl;
-			*nl = 0;
-		}
-		
-		irc_msgfrom( irc, u->nick, msg );
-		
-		/* Move on. */
-		if( nl )
-		{
-			*nl = tmp;
-			msg = nl + 1;
-		}
-		else
-		{
-			msg[425] = tmp;
-			msg += 425;
-		}
-	}
-	irc_msgfrom( irc, u->nick, msg );
+	wrapped = word_wrap( msg, 425 );
+	irc_msgfrom( irc, u->nick, wrapped );
+	g_free( wrapped );
 }
 
@@ -737,4 +710,5 @@
 {
 	struct im_connection *ic = c->ic;
+	char *wrapped;
 	user_t *u;
 	
@@ -749,8 +723,14 @@
 		strip_html( msg );
 	
+	wrapped = word_wrap( msg, 425 );
 	if( c && u )
-		irc_privmsg( ic->irc, u, "PRIVMSG", c->channel, "", msg );
+	{
+		irc_privmsg( ic->irc, u, "PRIVMSG", c->channel, "", wrapped );
+	}
 	else
-		imcb_log( ic, "Message from/to conversation %s@0x%x (unknown conv/user): %s", who, (int) c, msg );
+	{
+		imcb_log( ic, "Message from/to conversation %s@0x%x (unknown conv/user): %s", who, (int) c, wrapped );
+	}
+	g_free( wrapped );
 }
 
Index: tests/check_util.c
===================================================================
--- tests/check_util.c	(revision 285b55d3b38d6e1c8b3fc4a64945f2bb9ace07f4)
+++ tests/check_util.c	(revision d444c09e6c7ac6fc3c1686af0e63c09805d8cd00)
@@ -104,4 +104,61 @@
 END_TEST
 
+struct
+{
+	char *orig;
+	int line_len;
+	char *wrapped;
+} word_wrap_tests[] = {
+	{
+		"Line-wrapping is not as easy as it seems?",
+		16,
+		"Line-wrapping is\nnot as easy as\nit seems?"
+	},
+	{
+		"Line-wrapping is not as easy as it seems?",
+		8,
+		"Line-\nwrapping\nis not\nas easy\nas it\nseems?"
+	},
+	{
+		"Line-wrapping is\nnot as easy as it seems?",
+		8,
+		"Line-\nwrapping\nis\nnot as\neasy as\nit\nseems?"
+	},
+	{
+		"a aa aaa aaaa aaaaa aaaaaa aaaaaaa aaaaaaaa",
+		5,
+		"a aa\naaa\naaaa\naaaaa\naaaaa\na\naaaaa\naa\naaaaa\naaa",
+	},
+	{
+		"aaaaaaaa aaaaaaa aaaaaa aaaaa aaaa aaa aa a",
+		5,
+		"aaaaa\naaa\naaaaa\naa\naaaaa\na\naaaaa\naaaa\naaa\naa a",
+	},
+	{
+		"aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
+		5,
+		"aaaaa\naaaaa\naaaaa\naaaaa\naaaaa\naaaaa\naaaaa\na",
+	},
+	{
+		NULL
+	}
+};
+
+START_TEST(test_word_wrap)
+	int i;
+	
+	for( i = 0; word_wrap_tests[i].orig && *word_wrap_tests[i].orig; i ++ )
+	{
+		char *wrapped = word_wrap( word_wrap_tests[i].orig, word_wrap_tests[i].line_len );
+		
+		fail_unless( strcmp( word_wrap_tests[i].wrapped, wrapped ) == 0,
+		             "%s (line_len = %d) should wrap to `%s', not to `%s'",
+		             word_wrap_tests[i].orig, word_wrap_tests[i].line_len,
+		             word_wrap_tests[i].wrapped, wrapped );
+		
+		g_free( wrapped );
+	}
+END_TEST
+
 Suite *util_suite (void)
 {
@@ -116,4 +173,5 @@
 	tcase_add_test (tc_core, test_set_url_username);
 	tcase_add_test (tc_core, test_set_url_username_pwd);
+	tcase_add_test (tc_core, test_word_wrap);
 	return s;
 }
